org.springframework.transaction.interceptor

## Class AbstractFallbackTransactionAttributeSource

- java.lang.Object
- - org.springframework.transaction.interceptor.AbstractFallbackTransactionAttributeSource

- All Implemented Interfaces:
    TransactionAttributeSource
  Direct Known Subclasses:
    AnnotationTransactionAttributeSource

      public abstract class AbstractFallbackTransactionAttributeSource
      extends Object
      implements TransactionAttributeSource

  Abstract implementation of `TransactionAttributeSource` that caches attributes for methods and implements a fallback policy: 1. specific target method; 2. target class; 3. declaring method; 4. declaring class/interface.

  Defaults to using the target class's transaction attribute if none is associated with the target method. Any transaction attribute associated with the target method completely overrides a class transaction attribute. If none found on the target class, the interface that the invoked method has been called through (in case of a JDK proxy) will be checked.

  This implementation caches attributes by method after they are first used. If it is ever desirable to allow dynamic changing of transaction attributes (which is very unlikely), caching could be made configurable. Caching is desirable because of the cost of evaluating rollback rules.

  Since:
    1.1
  Author:
    Rod Johnson, Juergen Hoeller

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Log` | `logger` Logger available to subclasses.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractFallbackTransactionAttributeSource()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `allowPublicMethodsOnly()` Should only public methods be allowed to have transactional semantics?
    `protected abstract TransactionAttribute` | `findTransactionAttribute(Class<?> clazz)` Subclasses need to implement this to return the transaction attribute for the given class, if any.
    `protected abstract TransactionAttribute` | `findTransactionAttribute(Method method)` Subclasses need to implement this to return the transaction attribute for the given method, if any.
    `protected Object` | `getCacheKey(Method method, Class<?> targetClass)` Determine a cache key for the given method and target class.
    `TransactionAttribute` | `getTransactionAttribute(Method method, Class<?> targetClass)` Determine the transaction attribute for this method invocation.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### logger

          protected final Log logger

      Logger available to subclasses.

      As this base class is not marked Serializable, the logger will be recreated after serialization - provided that the concrete subclass is Serializable.

  - ### Constructor Detail

    - #### AbstractFallbackTransactionAttributeSource

          public AbstractFallbackTransactionAttributeSource()

  - ### Method Detail

    - #### getTransactionAttribute

          public TransactionAttribute getTransactionAttribute(Method method,
                                                              Class<?> targetClass)

      Determine the transaction attribute for this method invocation.

      Defaults to the class's transaction attribute if no method attribute is found.

      Specified by:
        `getTransactionAttribute` in interface `TransactionAttributeSource`
      Parameters:
        `method` - the method for the current invocation (never `null`)
        `targetClass` - the target class for this invocation (may be `null`)
      Returns:
        TransactionAttribute for this method, or `null` if the method is not transactional

    - #### getCacheKey

          protected Object getCacheKey(Method method,
                                       Class<?> targetClass)

      Determine a cache key for the given method and target class.

      Must not produce same key for overloaded methods. Must produce same key for different instances of the same method.

      Parameters:
        `method` - the method (never `null`)
        `targetClass` - the target class (may be `null`)
      Returns:
        the cache key (never `null`)

    - #### findTransactionAttribute

          protected abstract TransactionAttribute findTransactionAttribute(Method method)

      Subclasses need to implement this to return the transaction attribute for the given method, if any.
      Parameters:
        `method` - the method to retrieve the attribute for
      Returns:
        all transaction attribute associated with this method (or `null` if none)

    - #### findTransactionAttribute

          protected abstract TransactionAttribute findTransactionAttribute(Class<?> clazz)

      Subclasses need to implement this to return the transaction attribute for the given class, if any.
      Parameters:
        `clazz` - the class to retrieve the attribute for
      Returns:
        all transaction attribute associated with this class (or `null` if none)

    - #### allowPublicMethodsOnly

          protected boolean allowPublicMethodsOnly()

      Should only public methods be allowed to have transactional semantics?

      The default implementation returns `false`.